* _________________________________________________________________ / / /_
*                                                                  / / /
* http://cyberpingui.free.fr/sources.htm                    ____  / / /
* cracktro source                                           \   \/ / /
* ________________________________________ powered by AMIGA _\ \ \/ /_____
*                                                             \_\_\/
* D-Tect Boot intro "Hack-Mag #7"
* 
* resourced by VrS!
* 
; 40000-40400 :	1024 octets

;BOOT
	section	boot,code_c

	rsreset
flag	rs.w	1
ptsmp1	rs.b	1
ptsmp2	rs.b	1
VARSIZE	rs.w	0

	IFD	BOOT
Basecode=$40000
Screen=$50000
	
	dc.l	"DOS",0
	dc.l	0
	dc.l	880

Go:	bsr	Intro
; standard boot
	movea.l	4.w,a6
	lea	doslib(pc),a1
	jsr	-96(a6)

	tst.l	d0
	beq.s	.error
	movea.l	d0,a0
	movea.l	22(a0),a0
	moveq	#0,d0
.ok	rts
.error	moveq	#-1,d0
	bra.s	.ok
	
doslib	dc.b	'dos.library',0
	even
;---
Intro:	lea	code(pc),a0
	lea	Basecode,a1
	move.w	#lencode/4-1,d0
.cpy	move.l	(a0)+,(a1)+
	dbf	d0,.cpy

	jmp	Basecode

	ENDC

Start:	movem.l	d0-a6,-(sp)
	lea	$DFF000,a6
	move.w	#$7FFF,$9A(a6)
	move.w	#$8180,$96(a6)
	move.l	#CopperList,$80(a6)
	bset	#1,$BFE001	; filter off
			 
	lea	Screen(pc),a0 ; Screen buffer
	move.w	#(40*257)/4-1,d0	; 10280/4 = 40*257
.clear	clr.l	(a0)+
	dbf	d0,.clear
; copy logo
	lea	-(40*134+25)(a0),a0	; 40*134+25
	lea	Logo(pc),a1
	moveq	#11-1,d6
.loopy	moveq	#10-1,d7
.loopx	move.b	(a1)+,(a0)+
	dbf	d7,.loopx
	lea	30(a0),a0
	dbf	d6,.loopy 
	
	IFND	BOOT
	lea	Screen+40(pc),a0
	lea	CLlogo(pc),a1
	move.l	a0,d0
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	swap	d0
	subi.l	#40,d0
	move.w	d0,14(a1)
	swap	d0
	move.w	d0,10(a1)
	ENDC

InitSynth:
	lea	DataSynth(pc),a1		; $40150
	lea	smpBuffer-DataSynth(a1),a0	; $262 = $403B2
	moveq	#$B,d1
	moveq	#64-1,d7
.loop1	move.b	(a1)+,(a0)+
	move.b	d1,(a0)+
	dbf	d7,.loop1 
			 
	lea	smpBuffer-DataSynth+64(a1),a0	; $2A2 = $40432
	moveq	#16-1,d7
.loop2	move.b	(a1)+,d0
	move.b	d0,(a0)+
	move.b	d1,(a0)+
	subi.b	#10,d0
	move.b	d0,30(a0)
	move.b	d1,31(a0)
	addq.b	#2,d0
	move.b	d0,62(a0)
	move.b	d1,63(a0)
	addq.b	#4,d0
	move.b	d0,94(a0)
	move.b	d1,95(a0)
	dbf	d7,.loop2
; chan 0-1 
	lea	96(a0),a0
	move.l	a0,$A0(a6)	; aud0lc
	move.l	a0,$B0(a6)	; aud1lc
	moveq	#64,d0	; len sample "words"
	move.w	d0,$A4(a6)	; aud0len
	move.w	d0,$B4(a6)	; aud0lc
			 
	moveq	#66-1,d7
.norm	move.b	#127,66(a0)
	move.b	d0,128(a0)
	addq.b	#8,d0
	move.b	#-127,(a0)+
	dbf	d7,.norm
; chan 2-3			 
	lea	62(a0),a0
	move.l	a0,$C0(a6)	; aud2lc
	move.l	a0,$D0(a6)	; aud3lc
	moveq	#16,d1
	move.w	d1,$C4(a6)	; aud2len
	move.w	d1,$D4(a6)	; aud3len
	move.w	#$800F,$96(a6)	; dma audio on
;--- play
MainLoop:
	cmpi.b	#-1,6(a6)
	bne.s	MainLoop
	
	bsr	PlaySynth
	
	btst	#6,$BFE001
	bne.s	MainLoop
;--- end		 
	move.w	#$F,$96(a6)
	move.w	#$E02C,$9A(a6)
	movea.l	4.w,a6
	lea	GfxName(pc),a1	; "graphics.library"
	jsr	-$198(a6)
	movea.l	d0,a1
	move.l	$26(a1),$DFF080
	jsr	-$19E(a6)
	move.w	#$8020,$dff096	; sprites on
	movem.l	(sp)+,d0-a6
	rts	

GfxName:	
	dc.b 'graphics.library',0
	even

DataChannels:
	dc.l	smpBuffer+128	; $40432
	dc.b	0,0,0,$80
	dc.l	smpBuffer+128	; $40432
	dc.b	4,0,0,$80
	dc.l	smp		; $4038A
	dc.b	0,0,0,$A8
	dc.l	smp		; $4038A
	dc.b	4,0,0,$A8

DataSynth:	
	dc.b $22, $26, $28, $26, $22, $26, $28, $26, $22, $26
	dc.b $28, $26, $22, $26, $28, $26, $18, $1C, $1E, $1C
	dc.b $18, $1C, $1E, $1C, $18, $1C, $1E, $1C, $18, $1C
	dc.b $1E, $1C, $1A, $1E, $22, $1E, $1A, $1E, $22, $1E
	dc.b $1A, $1E, $22, $1E, $1A, $1E, $22, $1E, $1E
	dc.b $22, $26, $22, $1E, $22, $26, $22, $1E, $22, $26
	dc.b $22, $1E, $22, $26, $22, $A, $A, $22, $A, $A
	dc.b $22, $A, $22, $A, $A, $22, $A, $A, $22, $A, $22

vars:	ds.b	VARSIZE
	even


PlaySynth:
	lea	vars(pc),a0
	not.w	flag(a0)
	beq.s	.play
	addq.b	#1,ptsmp1(a0)	; ->63
	subq.b	#1,ptsmp2(a0)	; ->31
	andi.w	#$3F1F,ptsmp1(a0)
	move.b	ptsmp1(a0),d0
	lea	smpBuffer+256,a1		; $404B2
	neg.b	(a1,d0.w)
	move.b	ptsmp2(a0),d0
	lea	smpBuffer+256+128,a1		; $40532
	addq.b	#8,(a1,d0.w)

.play:	moveq	#4,d7
	lea	DataChannels(pc),a5
	lea	$A6(a6),a3	; aud0per : period
	bsr.s	PlayVoice	; chan0
	bsr.s	PlayVoice	; chan1
	subq.w	#1,d7
	bsr.w	*+4		; chan2
				; chan3
PlayVoice:
	movea.l	(a5)+,a4
	subq.b	#1,(a5)
	bpl.s	.sup
	move.b	2(a5),d0
	move.b	(a4,d0.w),d1
	move.b	1(a4,d0.w),(a5)
	move.w	period(pc,d1.w),(a3)
	move.b	#$44,1(a5)
	addq.b	#2,2(a5)
	move.b	2(a5),d1
	cmp.b	3(a5),d1
	bne.s	.sup
	sf	2(a5)
.sup
	move.b	1(a5),d1
	beq.s	.next
	sub.b	d7,1(a5)
	move.w	d1,2(a3)

.next	addq.w	#4,a5		; next channel
	lea	$10(a3),a3	;
	rts

period:	dc.w $23A, $21A, $1FC, $1E0, $1C5, $1AC, $194, $17D, $168
	dc.w $153, $140, $12E, $11D, $10D, $FE,	$F0, $E2, $D6
	dc.w $CA, $BE, $B4, $AA, $A0
;---------------------------------------
CopperList:	
	dc.w	$100,$2200
CLlogo	dc.w	$E0,5,$E2,$28
	dc.w	$E4,5,$E6,0
	dc.w	$96,$20		; sprites off
	dc.w	$180,0
	dc.w	$184,$234
	dc.w	$186,$0F0
	dc.w	$102,$010
	dc.w	$108,0,$10A,0
	dc.w	$8E,$2C81,$90,$2CC1
	dc.w	$92,$38,$94,$D0

	dc.w	$990F,$FFFE,$180,$CCF
	dc.w	$9A0F,$FFFE,$180,$005

	dc.w	$A70F,$FFFE,$182,$8F8,$186,$8F8
	dc.w	$A80F,$FFFE,$182,$AFA,$186,$AFA
	dc.w	$A90F,$FFFE,$182,$CFC,$186,$CFC
	dc.w	$AA0F,$FFFE,$182,$EFE,$186,$EFE
	dc.w	$AB0F,$FFFE,$182,$CFC,$186,$CFC
	dc.w	$AC0F,$FFFE,$182,$AFA,$186,$AFA
	dc.w	$AD0F,$FFFE,$182,$8F8,$186,$8F8
	dc.w	$AE0F,$FFFE,$182,$0F0,$186,$0F0

	dc.w	$BC0F,$FFFE,$180,$CCF
	dc.w	$BD0F,$FFFE,$180,0

	dc.l	-2
	dc.l	-2

Logo:	incbin	"logo.rw"
;---------------------------------------
smp:	dc.w	$280B,$223B
	dc.w	$2817,$2C2F
	dc.w	$282F,$1E0B
	dc.w	$183B,$1E17
	dc.w	$222F,$1E2F
	dc.w	$220B,$1A3B
	dc.w	$2217,$262F
	dc.w	$222F,$260B
	dc.w	$1E3B,$2617
	dc.w	$282F,$262F
lencode	= *-Start

smpBuffer	; $403B2
	IFND	BOOT
	ds.b	1024

Screen	ds.b	40*257
	ENDC

	END
